
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Cahier des charges - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#cahier-des-charges">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Cahier des charges
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Cahier des charges
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Cahier des charges
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#sujet">
    Sujet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#but">
    But
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#specifications">
    Spécifications
  </a>
<nav aria-label="Spécifications" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#interfaces">
    Interfaces
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#restriction">
    Restriction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#environnement">
    Environnement
  </a>
<nav aria-label="Environnement" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#languague-de-programmation">
    Languague de programmation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#systeme-dexploitation">
    Système d'exploitation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#versionning">
    Versionning
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#livrable">
    Livrable
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../7_Architecture/">
        Architecture
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../9_installationEnvironnement/">
        Installation de l'environnement
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../10_EncryptionBdd/">
        Encryption de base de données
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../docClasse/">
        Description Classes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../conclusion/">
        Conclusion
      </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#sujet">
    Sujet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#but">
    But
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#specifications">
    Spécifications
  </a>
<nav aria-label="Spécifications" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#interfaces">
    Interfaces
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#restriction">
    Restriction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#environnement">
    Environnement
  </a>
<nav aria-label="Environnement" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#languague-de-programmation">
    Languague de programmation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#systeme-dexploitation">
    Système d'exploitation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#versionning">
    Versionning
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#livrable">
    Livrable
  </a>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="cahier-des-charges">Cahier des charges</h1>
<h2 id="sujet">Sujet</h2>
<p>Création d'un gestionnaire de portefeuilles crypto.</p>
<h2 id="but">But</h2>
<p>créer une application C# poposant la création de différents portefeuilles crypto, ainsi que de rendre possible l'échange entre les différentes cryptomonnaies. Rendre plus simple le suivi pour les personnes détenant plusieurs portefeuilles. Visualiser simplement l'évolution des portefeuilles.</p>
<h2 id="specifications">Spécifications</h2>
<p>Au démarrage de l'application il est demandé de se connnecter ou créer un compte (Double authentification Google). Quand l'utilisateur sera connecté il lui sera possible de créer ou d'importer un portefeuille (HD Wallet) de cryptomonnaie ERC-20 (Blockchain Ethereum). L'utilisateur aura également la possibilité de créer une transaction à l'adresse désiré. Il y aura une Form qui permet de visualiser la valeur total ou celle des différents portefeuilles. Une interface permettant de suivre les profits ou les pertes sur un lapse de temps que l'utilisateur peut modifier. </p>
<p>Pour stocker les données j'aurais également a créer un base de données encrypté At-Rest qui signifie qu'aucune données ne sera écrite en clair sur le disque. Pour pousser plus loin la sécurité il sera nécessaire de forcer une connexion TLS/SLL ce qui me permetra d'encrypter les données qui voyage entre le client et le serveur MySQL.</p>
<p>Pour communiquer avec une blockchain je vais utiliser la librairie Web3.js plus précisement le package web3-eth. Toute les méthodes dont je vais avoir besoin sont disponible dans cette librairie.</p>
<p>Pour faciliter le développement je vais utiliser un serveur Hardhat qui me permet de faire tourner une blockchain localement. Cette blockchain en question sera une copie de la blockchain Ethereum pour me rapprocher le maximum possible de la réaliter.</p>
<h3 id="interfaces">Interfaces</h3>
<p>Login :</p>
<figure id="fig12" style="width: 40%">
<img alt="Mockup connexion" src=".././img/login.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 12]:</span><b>Mockup connexion</b> </figcaption>
</figure>
<p>Page d'accueil :</p>
<figure id="fig13" style="width: 40%">
<img alt="Mockup acceuil" src=".././img/walletConnecte.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 13]:</span><b>Mockup acceuil</b> </figcaption>
</figure>
<p>Paramètres du comtpe :</p>
<figure id="fig14" style="width: 40%">
<img alt="Mockup paramètres" src=".././img/parametres.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 14]:</span><b>Mockup paramètres</b> </figcaption>
</figure>
<p>Créer un compte :</p>
<figure id="fig15" style="width: 40%">
<img alt="Mockup créer compte" src=".././img/creerCompte.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 15]:</span><b>Mockup créer compte</b> </figcaption>
</figure>
<p>Importer un compte :</p>
<figure id="fig16" style="width: 40%">
<img alt="Mockup importer compte" src=".././img/importerCompte.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 16]:</span><b>Mockup importer compte</b> </figcaption>
</figure>
<h2 id="restriction">Restriction</h2>
<p>Aucune</p>
<h2 id="environnement">Environnement</h2>
<h3 id="languague-de-programmation">Languague de programmation</h3>
<ul>
<li>C#</li>
<li>Mysql</li>
</ul>
<h3 id="systeme-dexploitation">Système d'exploitation</h3>
<ul>
<li>Windows 10</li>
<li>WSL2 (Serveur HTTP Apache 2)</li>
<li>Harhat</li>
</ul>
<h3 id="versionning">Versionning</h3>
<ul>
<li>GitHub</li>
</ul>
<h2 id="livrable">Livrable</h2>
<ul>
<li>Fichier zip contenant le projet</li>
<li>Documentation et poster au format PDF</li>
<li>Journal de bord</li>
</ul>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Introduction" class="md-footer__link md-footer__link--prev" href="../1_Resume/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Introduction
            </div>
</div>
</a>
<a aria-label="Next: Planning" class="md-footer__link md-footer__link--next" href="../3_planning/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Planning
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>